#ifndef __GCInvoiceData_Account_h__
#define __GCInvoiceData_Account_h__

#include <GCInvoiceData/Base.h>

#include <librfcdal/DalDatabase.h>

#include <string>
#include <map>

namespace GCInvoiceData
{
	class GCINVOICEDATASHARED_EXPORT Account : public Base
	{
		private:
			std::string _strTitle;

		public:
			Account();
			Account( const Base::Key& key );
			Account( const Account& account );
			virtual ~Account();

			Account& operator=( const Account& account );

			const std::string& title() const;

			void setTitle( const std::string& strTitle );

			static Account fromRow( const RfcDal::DalDatabase::Row& row );
			static Account create( const Account& temp );
			void update();
			void remove();
	};

	class GCINVOICEDATASHARED_EXPORT AccountMap : public std::map<Base::Key, Account>
	{
		public:
			static AccountMap fromResult( const RfcDal::DalDatabase::Result& result );
	};
}

#endif /* !__GCInvoiceData_Account_h__ */
