#ifndef __GCInvoiceData_Base_h__
#define __GCInvoiceData_Base_h__

#include <GCInvoiceData/gcinvoicedata_global.h>

namespace GCInvoiceData
{
	class GCINVOICEDATASHARED_EXPORT Base
	{
		public:
			class GCINVOICEDATASHARED_EXPORT Key
			{
				private:
					int _nKey;

				public:
					Key();
					Key( int nKey );
					Key( const Key& key );
					virtual ~Key();

					Key& operator=( const Key& key );
					bool operator==( const Key& key ) const;
					bool operator!=( const Key& key ) const;
					bool operator<( const Key& key ) const;

					int key() const;
			};

		private:
			Key _key;

		public:
			Base();
			Base( const Key& key );
			Base( const Base& base );
			virtual ~Base();

			Base& operator=( const Base& base );

			const Key& key() const;

			virtual void update() = 0;
			virtual void remove() = 0;
	};
}

#endif /* !__GCInvoiceData_Base_h__ */
