#ifndef __GCInvoiceData_GCInvoiceData_h__
#define __GCInvoiceData_GCInvoiceData_h__

#include <GCInvoiceData/gcinvoicedata_global.h>

#include <GCInvoiceData/Profile.h>
#include <GCInvoiceData/Account.h>
#include <GCInvoiceData/Customer.h>
#include <GCInvoiceData/Product.h>
#include <GCInvoiceData/Invoice.h>

namespace GCInvoiceData
{
	class GCINVOICEDATASHARED_EXPORT Factory
	{
		private:
			static ProfileMap _profileS;
			static AccountMap _accountS;
			static CustomerMap _customerS;
			static ProductMap _productS;
			static InvoiceMap _invoiceS;

			static int _nCurrentInvoiceNumber;
			static const Invoice* _pinvoiceClipboard;

		public:
			static void initialize();

			static ProfileMap& profile();
			static AccountMap& accounts();
			static CustomerMap& customers();
			static ProductMap& products();
			static InvoiceMap& invoices();

			static void setCurrentInvoiceNumber( int nCurrent );
			static int nextInvoiceNumber();
			static Invoice& createCustomerInvoice( int nInvoiceNo, const Base4c::Date& dtInvoice, const Customer& customer, bool bShow = true );

			static void deleteAllInvoices();
			static void copyInvoice( const Invoice& invoice );
			static const Invoice* pasteInvoice();
	};
}

#endif /* !__GCInvoiceData_GCInvoiceData_h__ */
