#ifndef __GCInvoiceData_Product_h__
#define __GCInvoiceData_Product_h__

#include <GCInvoiceData/Base.h>

#include <GCInvoiceData/Account.h>

#include <librfcdal/DalDatabase.h>

#include <string>
#include <map>

namespace GCInvoiceData
{
	class GCINVOICEDATASHARED_EXPORT Product : public Base
	{
		private:
			std::string _strDescription;
			double _dPrice;
			const Account* _paccount;
			bool _bTaxable;

		public:
			Product();
			Product( const Base::Key& key );
			Product( const Product& product );
			virtual ~Product();

			Product& operator=( const Product& product );

			const std::string& description() const;
			double price() const;
			const Account& account() const;
			bool taxable() const;

			void setDescription( const std::string& strDescription );
			void setPrice( double dPrice );
			void setAccount( const Account& account );
			void setTaxable( bool bTaxable );

			static Product fromRow( const RfcDal::DalDatabase::Row& row );
			static Product create( const Product& temp );
			void update();
			void remove();
	};

	class GCINVOICEDATASHARED_EXPORT ProductMap : public std::map<Base::Key, Product>
	{
		public:
			static ProductMap fromResult( const RfcDal::DalDatabase::Result& result );
	};
}

#endif /* !__GCInvoiceData_Product_h__ */
