#ifndef __GCInvoiceData_Profile_h__
#define __GCInvoiceData_Profile_h__

#include <GCInvoiceData/gcinvoicedata_global.h>

#include <GCInvoiceDal/ProfileKeys.h>

#include <librfcdal/DalDatabase.h>

#include <string>
#include <map>

namespace GCInvoiceData
{
	class GCINVOICEDATASHARED_EXPORT Profile : public GCInvoiceDal::Profile
	{
		public:
			class GCINVOICEDATASHARED_EXPORT Key
			{
				private:
					std::string _strKey;

				public:
					Key();
					Key( const std::string& strKey );
					Key( const Key& key );
					virtual ~Key();

					Key& operator=( const Key& key );
					bool operator==( const Key& key ) const;
					bool operator!=( const Key& key ) const;
					bool operator<( const Key& key ) const;

					const std::string& key() const;
			};

		private:
			Key _key;
			std::string _strDescription;
			std::string _strValue;

		public:
			Profile();
			Profile( const Profile::Key& key );
			Profile( const Profile& profile );
			virtual ~Profile();

			Profile& operator=( const Profile& profile );

			const Key& key() const;
			const std::string& description() const;
			const std::string& value() const;

			void setDescription( const std::string& strDescription );
			void setValue( const std::string& strValue );

			static Profile fromRow( const RfcDal::DalDatabase::Row& row );
			static Profile create( const Profile& temp );
			void update();
			void remove();
	};

	class GCINVOICEDATASHARED_EXPORT ProfileMap : public std::map<Profile::Key, Profile>
	{
		public:
			static ProfileMap fromResult( const RfcDal::DalDatabase::Result& result );
	};
}

#endif /* !__GCInvoiceData_Profile_h__ */
